package jp.mosp.common.part;

import java.sql.SQLException;
import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.dao.CmCodeDao;
import jp.mosp.common.dto.CmCodeDto;

/**
 * 共通コードに関するPartクラス
 * @author yoshida
 *	@version	0.0.1
 */
public class CmCodePart extends BasePart {

	/**
	 * コンストラクタ
	 */
	public CmCodePart() {
		super();
	}

	/**
	 * コンストラクタ
	 * @param partInfo
	 */
	public CmCodePart(PartInfo partInfo) {
		super(partInfo);
	}

	/**
	 * 
	 * @return
	 * @throws Exception
	 */
	public CmCodeDao getCmCodeDao() throws Exception {
		return (CmCodeDao)getPreparedDao(CmCodeDao.class.getCanonicalName());
	}

	/**
	 * コードリスト取得(CM_CODE)
	 * @param tId コード区分
	 * @return コードリスト
	 * @throws Exception 
	 */
	public String[][] getCodeArray(String tId) throws Exception {
		// データの取得
		List<CmCodeDto> list = getCmCodeDao().findForCondition(tId);
		// データの整形
		String[][] array = new String[list.size()][2];
		for (int i = 0; i < list.size(); i++) {
			CmCodeDto dto = list.get(i);
			array[i][0] = dto.getTCode();
			array[i][1] = dto.getTName();
		}
		return array;
	}

	/**
	 * コード区分取得(CM_CODE)
	 * @return コード区分リスト
	 * @throws Exception 
	 */
	public String[][] getCodeArray() throws Exception {
		// コード区分の取得(distinctデータ)
		List<CmCodeDto> list = getCmCodeDao().findAllTId();     
		String[][] aryCode = new String[list.size()][2];
		// Stingの配列に格納
		for (int i = 0; i < list.size(); i++) {
			String tId = list.get(i).getTId();
			aryCode[i][0] = tId;
			aryCode[i][1] = getCodeTypeName(tId);
		}
		return aryCode;
	}

	/**
	 * コード区分名称取得(CM_CODE)
	 * @param	tId コード区分
	 * @return	tId コード区分名称
	 * @throws SQLException
	 * @throws NoSuchFieldException
	 * @throws IllegalAccessException
	 */
	public String getCodeTypeName(String tId) {
		if (tId.equals(CommonConst.TID_AUTHORITY)) {
			return CommonConst.TNM_AUTHORITY;
		} else {
			return tId;
		}
	}

	/**
	 * 和暦元号配列
	 * @return	和暦元号配列
	 * @throws Exception
	 */
	public String[][] getJPCalendarGengo() throws Exception {
		String[][] array = CommonConst.getJpCalendarGengo();
		String[][] aryGengo = getCodeArray(CommonConst.TID_JAPANESE);
		if (aryGengo.length > array.length) {
			array = aryGengo;
		}
		return array;
	}

}
